=== debian/control ===
Source: ros-melodic-psen-scan-v2
Section: misc
Priority: optional
Maintainer: Alexander Gutenkunst <a.gutenkunst@pilz.de>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-code-coverage, ros-melodic-pilz-testutils, ros-melodic-rosbag, ros-melodic-rosconsole-bridge, ros-melodic-roscpp, ros-melodic-rosfmt, ros-melodic-roslaunch, ros-melodic-rostest, ros-melodic-rosunit, ros-melodic-sensor-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-psen-scan-v2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-robot-state-publisher, ros-melodic-rosconsole-bridge, ros-melodic-roscpp, ros-melodic-rosfmt, ros-melodic-roslaunch, ros-melodic-rviz, ros-melodic-sensor-msgs, ros-melodic-xacro
Description: ROS support for the Pilz laser scanner
