=== debian/control ===
Source: ros-melodic-psen-scan-v2
Section: misc
Priority: optional
Maintainer: Alexander Gutenkunst <a.gutenkunst@pilz.de>
Build-Depends: debhelper (>= 9.0.0), libfmt-dev, libtinyxml2-dev, ros-melodic-catkin, ros-melodic-cmake-modules, ros-melodic-code-coverage <!nocheck>, ros-melodic-geometry-msgs, ros-melodic-message-generation, ros-melodic-rosbag <!nocheck>, ros-melodic-rosconsole-bridge, ros-melodic-roscpp, ros-melodic-roslaunch <!nocheck>, ros-melodic-rostest <!nocheck>, ros-melodic-rosunit <!nocheck>, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-psen-scan-v2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfmt-dev, libtinyxml2-dev, ros-melodic-geometry-msgs, ros-melodic-message-runtime, ros-melodic-robot-state-publisher, ros-melodic-rosconsole-bridge, ros-melodic-roscpp, ros-melodic-roslaunch, ros-melodic-rviz, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-visualization-msgs, ros-melodic-xacro
Description: ROS support for the Pilz laser scanner
